library bot;

import 'dart:collection';
import 'dart:math' as math;
import 'package:meta/meta.dart';

part 'src/bot/annotations.dart';
part 'src/bot/requires.dart';
part 'src/bot/string_line_reader.dart';
part 'src/bot/tuple.dart';
part 'src/bot/tuple3.dart';
part 'src/bot/typedefs.dart';
part 'src/bot/util.dart';

part 'src/bot/attached/attachable.dart';
part 'src/bot/attached/attachable_object.dart';
part 'src/bot/attached/attached_event.dart';
part 'src/bot/attached/property.dart';

part 'src/bot/cloneable.dart';

part 'src/bot/collection/array_2d.dart';
part 'src/bot/collection/collection_util.dart';
part 'src/bot/collection/enumerable.dart';
part 'src/bot/collection/grouping.dart';
part 'src/bot/collection/list_base.dart';
part 'src/bot/collection/number_enumerable.dart';
part 'src/bot/collection/read_only_collection.dart';

part 'src/bot/color/hsl_color.dart';
part 'src/bot/color/husl_converter.dart';
part 'src/bot/color/rgb_color.dart';

part 'src/bot/disposable.dart';
part 'src/bot/disposable_impl.dart';

part 'src/bot/events/cancelable_event_args.dart';
part 'src/bot/events/event_root.dart';
part 'src/bot/events/event_args.dart';
part 'src/bot/events/event_handle.dart';

part 'src/bot/exceptions/detailed_argument_error.dart';
part 'src/bot/exceptions/invalid_operation_error.dart';
part 'src/bot/exceptions/null_argument_error.dart';

part 'src/bot/global_id.dart';

part 'src/bot/math/affine_transform.dart';
part 'src/bot/math/box.dart';
part 'src/bot/math/bungee_num.dart';
part 'src/bot/math/coordinate.dart';
part 'src/bot/math/math_functions.dart';
part 'src/bot/math/size.dart';
part 'src/bot/math/tarjan_cycle_detect.dart';
part 'src/bot/math/vector.dart';
